function [ frame_out ] = decode_I_frame( frame_encoded, B_size, MB_size, Q  )

enc_luma = frame_encoded.encoded_luma;
enc_chroma = frame_encoded.encoded_chroma;

Nmb = size(enc_luma)/MB_size;

Y_mb = mat2cell(enc_luma, repmat(MB_size,1,Nmb(1)), repmat(MB_size,1,Nmb(2)));
Y_decoded = cell(size(Y_mb));

chroma_mb = mat2cell(enc_chroma, repmat(MB_size/2,1,Nmb(1)), repmat(MB_size/2,1,Nmb(2)),2);
chroma_decoded = cell(size(chroma_mb));

for m = 1 : Nmb(1)
    for n = 1 : Nmb(2)
        Y_decoded{m,n} = inverse_quantize( Y_mb{m,n}, MB_size, B_size, Q );
        chroma_decoded{m,n} = inverse_quantize( chroma_mb{m,n}, MB_size, B_size, Q );
    end
end
Y_decoded = cell2mat(Y_decoded);
chroma_decoded = cell2mat(chroma_decoded);

frame_out = YCbCr_to_RGB( Y_decoded, chroma_decoded );


end

